﻿Imports System.Windows
Imports System.ComponentModel.Composition
Imports System.ComponentModel.Composition.Hosting

Imports Utils.Silverlight.MVVM
Imports Utils.Demo.ContosoSales.MVVM.Views

Namespace Utils.Demo.ContosoSales
	Partial Public Class App
		Inherits Application
		''' <summary>
		''' The main view will be imported by MEF.
		''' </summary>
        <Import()>
  Public Property MainView() As MainView
            Get
                Return TryCast(RootVisual, MainView)
            End Get
            Set(ByVal value As MainView)
                RootVisual = value
            End Set
        End Property

		Public Sub New()
			InitializeComponent()
		End Sub

		''' <summary>
		''' When the application starts, start doing our registrations and then import the required objects.
		''' </summary>
		''' <param name="sender"></param>
		''' <param name="e"></param>
		Private Sub OnStart(ByVal sender As Object, ByVal e As StartupEventArgs)
			' Initialize the container using a deployment catalog.
			Dim catalog = New DeploymentCatalog()
			Dim container = CompositionHost.Initialize(catalog)

			' Export the container as singleton.
			container.ComposeExportedValue(Of CompositionContainer)(container)

			' Make sure the MainView is imported.
			CompositionInitializer.SatisfyImports(Me)
		End Sub

		''' <summary>
		''' Show error on exception.
		''' </summary>
		''' <param name="sender"></param>
		''' <param name="e"></param>
		Private Sub OnException(ByVal sender As Object, ByVal e As ApplicationUnhandledExceptionEventArgs)
			If Not Debugger.IsAttached Then
				e.Handled = True
				Dim w As New ErrorWindow(e.ExceptionObject)
				w.Show()
			End If
		End Sub
	End Class
End Namespace