﻿Imports System.Windows.Input
Imports System.Windows.Browser

Imports GalaSoft.MvvmLight.Command

Imports Utils.Silverlight.MVVM
Imports Utils.Demo.ContosoSales.Properties

Namespace Utils.Demo.ContosoSales.MVVM.ViewModels
    <ViewModelExport(GetType(IAboutViewModel), "About")>
 Public Class AboutViewModel
        Inherits ContosoViewModelBase
        Implements IAboutViewModel
        ''' <summary>
        ''' Gets or sets the about text.
        ''' </summary>
        ''' <value>The about text.</value>
        Public Property AboutText() As String Implements IAboutViewModel.AboutText

        ''' <summary>
        ''' Gets or sets the View's title.
        ''' </summary>
        ''' <value>The View's title.</value>
        Public Property ViewTitle() As String Implements IAboutViewModel.ViewTitle
         
        ''' <summary>
        ''' Gets or sets the open website command.
        ''' </summary>
        ''' <value>The open website command.</value>
        Public Property OpenWebsiteCommand() As ICommand Implements IAboutViewModel.OpenWebsiteCommand

        Public Sub New()
            AboutText = Resources.About
            ViewTitle = "Contoso Sales / About"
            OpenWebsiteCommand = New RelayCommand(AddressOf OnShowContosoPage)
        End Sub

        ''' <summary>
        ''' Show the contoso homepage in the browser.
        ''' </summary>
        Private Sub OnShowContosoPage()
            Dim uri = New Uri("http://en.wikipedia.org/wiki/Contoso")
            HtmlPage.PopupWindow(uri, "", New HtmlPopupWindowOptions())
        End Sub

        Public Overrides Function GetViewTitle() As String
            Return "About"
        End Function
    End Class
End Namespace
