﻿Imports System.ComponentModel.Composition
Imports GalaSoft.MvvmLight
Imports Utils.Silverlight.MVVM
Imports Utils.Silverlight.MVVM.Navigation

Namespace Utils.Demo.ContosoSales.MVVM.ViewModels
	Public MustInherit Class ContosoViewModelBase
		Inherits ViewModelBase
		Implements IViewModel
		''' <summary>
		''' The navigation service allows you to navigate to an other ViewModel.
		''' </summary>

        <Import()>
        Public Property NavigationService() As INavigationService

		''' <summary>
		''' Method will be called once the ViewModel is completely loaded and attached to the View.
		''' </summary>
        Public Overridable Sub OnLoaded() Implements IViewModel.OnLoaded
            Debug.WriteLine(CType(NavigationService, Object).GetHashCode())
        End Sub

		''' <summary>
		''' Method will be called once the navigation is done.
		''' The args will contain all arguments that were passed while navigating.
		''' </summary>
		''' <param name="args"></param>
        Public Overridable Sub OnNavigated(ByVal args As NavigationArguments) Implements IViewModel.OnNavigated

        End Sub

		''' <summary>
		''' Get the title to display after navigating.
		''' </summary>
		''' <returns></returns>
        Public Function GetTitle() As String Implements IViewModel.GetTitle
            Return "Contoso Sales / " & GetViewTitle()
        End Function

		''' <summary>
		''' Make sure each ViewModel can provide a title.
		''' </summary>
		''' <returns></returns>
		Public MustOverride Function GetViewTitle() As String
	End Class
End Namespace
