﻿Imports System.ComponentModel.Composition
Imports Utils.Silverlight.MVVM
Imports Utils.Silverlight.MVVM.Navigation
Imports Utils.Demo.ContosoSales.MVVM.Model

Namespace Utils.Demo.ContosoSales.MVVM.ViewModels
    <ViewModelExport(GetType(IEmployeeDetailViewModel), "Employee/{lastname}")>
 Public Class EmployeeDetailViewModel
        Inherits ContosoViewModelBase
        Implements IEmployeeDetailViewModel
        ''' <summary>
        ''' The service giving access to the data.
        ''' </summary>
        <Import()>
        Public Property DataService() As IDataService Implements IEmployeeDetailViewModel.DataService

        ''' <summary>
        ''' Employee field.
        ''' </summary>

        Private _employee As Employee

        ''' <summary>
        ''' The current employee.
        ''' </summary>
        Public Property Employee() As Employee Implements IEmployeeDetailViewModel.Employee
            Get
                Return _employee
            End Get
            Set(ByVal value As Employee)
                _employee = value
                RaisePropertyChanged("Employee")
            End Set
        End Property

        ''' <summary>
        ''' After navigating get the employee's name and load the employee.
        ''' </summary>
        ''' <param name="args"></param>
        Public Overrides Sub OnNavigated(ByVal args As NavigationArguments)
            Dim lastname = args.GetString("lastname")
            If lastname IsNot Nothing Then
                Employee = DataService.GetEmployeeByLastname(lastname)
            End If
        End Sub

        ''' <summary>
        ''' Get the employee's lastname as title.
        ''' </summary>
        ''' <returns></returns>
        Public Overrides Function GetViewTitle() As String
            If Employee IsNot Nothing Then
                Return Employee.Lastname
            Else
                Return "Employee Detail"
            End If
        End Function
    End Class
End Namespace
