﻿Imports System.ComponentModel.Composition

Namespace Utils.Silverlight.MVVM
    <MetadataAttribute(), AttributeUsage(AttributeTargets.Class, AllowMultiple:=False)>
    Public Class ViewExportAttribute
        Inherits ExportAttribute
        Implements IViewMetadata
        ''' <summary>
        ''' Specifies the required ViewModel.
        ''' </summary>
        Private _ViewModelContract As Type
        Public ReadOnly Property ViewModelContract() As Type Implements IViewMetadata.ViewModelContract
            Get
                Return _ViewModelContract
            End Get
        End Property

        Public Property Set_ViewModelContract() As Type
            Get
                Return _ViewModelContract
            End Get
            Set(ByVal value As Type)
                _ViewModelContract = value
            End Set
        End Property

        ''' <summary>
        ''' Initializes a new instance of the <see cref="ViewExportAttribute"/>class.
        ''' </summary>
        Public Sub New()
            MyBase.New(GetType(IView))

        End Sub
    End Class
End Namespace
