﻿Namespace Utils.Silverlight.MVVM
	Public Interface IViewModelMetadata
		''' <summary>
		''' The actual interface of the ViewModel.
		''' This type will be used to match a View to a ViewModel.
		''' </summary>
		ReadOnly Property ViewModelContract() As Type

		''' <summary>
		''' Specify to which navigation key this ViewModel should be mapped.
		''' Eg: 'Customers', or 'Customer/1'
		''' </summary>
		ReadOnly Property NavigationPath() As String

		''' <summary>
		''' This is the actual navigation key. 
		''' 'Customer/1' would have as key: 'Customer'.
		''' </summary>
		ReadOnly Property Key() As String
	End Interface
End Namespace
