﻿Imports System.Windows.Controls
Imports System.ComponentModel.Composition

Namespace Utils.Silverlight.MVVM.Navigation
	''' <summary>
    ''' Wrapper for <see cref="Frame"/>to abstract the navigation process.
    ''' </summary>
    <Export(GetType(INavigationService))>
    Public Class NavigationService
        Implements INavigationService
        ''' <summary>
        ''' The frame doing the actual navigation.
        ''' </summary>
        Private navigationFrame As Frame

        ''' <summary>
        ''' Initialize the service by storing the frame.
        ''' </summary>
        ''' <param name="navigationFrame"></param>
        Public Sub New(ByVal navigationFrame As Frame)
            Me.navigationFrame = navigationFrame
        End Sub

        ''' <summary>
        ''' Navigate to a given path.
        ''' </summary>
        ''' <param name="path"></param>
        Public Sub Navigate(ByVal path As String) Implements INavigationService.Navigate
            navigationFrame.Navigate(New Uri(path, UriKind.Relative))
        End Sub

        ''' <summary>
        ''' Navigate to a given path and process some arguments.
        ''' </summary>
        ''' <param name="path"></param>
        ''' <param name="args"></param>
        Public Sub Navigate(ByVal path As String,
                            ByVal ParamArray args() As Object) Implements INavigationService.Navigate
            Navigate(String.Format(path, args))
        End Sub
    End Class
End Namespace
